//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function [x,y,typ]=PIDfiltered(job,arg1,arg2)
    x=[];y=[];typ=[];
    select job
    case 'plot' then
        // deprecated
    case 'getinputs' then
        // deprecater
    case 'getoutputs' then
        // deprecated
    case 'getorigin' then
        // deprecated
    case 'set' then
        x=arg1;
        graphics=arg1.graphics;
        exprs=graphics.exprs
        model=arg1.model;

        while %t do
            [ok,P,I,D,wc,exprs]=scicos_getvalue('Set PID parameters',..
            [gettext('Proportionnal gain');gettext('Integral gain');gettext('Derivative gain');gettext('Bandwith for derivative')],list('vec',1,'vec',1,'vec',1,'vec',1), exprs)
            mess=[];

            if ~ok then break; end

            if ok then
                disp("ok")
                model.rpar.objs(1).graphics.exprs=[string(I)+"*"+string(wc)+"+("+string(I)+"+"+string(wc)+'*'+string(P)+')*s+('+string(D)+'*'+string(wc)+'+'+string(P)+')*s^2';'s^2+'+string(wc)+'*s']
                model.rpar.objs(1).model.rpar=[0;0;1;-wc;0;1;wc*I;I-D*wc^2;D*wc+P];
                model.rpar.objs(1).model.state=[0;0]
                graphics.exprs = exprs;
                x.model=model;
                x.graphics = graphics;
                break
            else
                message(mess);
            end

        end
    case 'define' then
        P=1; I=0; D=0; wc=1e6;   
        diagram=scicos_diagram();
//        gain_p=GAINBLK_f('define')
//        gain_p.model.rpar=P;
//        gain_p.graphics.pin=12;
//        gain_p.graphics.pout=16;
//        gain_i=GAINBLK_f('define')
//        gain_i.model.rpar=I;
//        gain_i.graphics.pin=14;
//        gain_i.graphics.pout=17;      
//        gain_d=GAINBLK_f('define')
//        gain_d.model.rpar=D;
//        gain_d.graphics.pin=15;
//        gain_d.graphics.pout=18;    
//        fct_d=CLR('define');
//        fct_d.model.rpar=[-wc;1;wc^2;wc];
//        fct_d.graphics.pin=18;
//        fct_d.graphics.pout=20;    
//        fct_i=INTEGRAL_m('define');
//        fct_i.graphics.pin=17;
//        fct_i.graphics.pout=19;   
//        sum=BIGSOM_f('define')
//        sum.model.in=-1*ones(3,1);
//        sum.model.in2=ones(3,1);
//        sum.model.intyp=ones(3,1);
//        sum.model.rpar=ones(3,1);
//        sum.graphics.pin=[16 ;19 ;20];
//        sum.graphics.pout=21;        
//        split_1=SPLIT_f('define')
//        split_1.graphics.pin=11;
//        split_1.graphics.pout=[12;13];         
//        split_2=SPLIT_f('define');
//        split_2.graphics.pin=13;
//        split_2.graphics.pout=[14;15];
//        input_port=IN_f('define');
//        input_port.graphics.pout=11;
//        output_port=OUT_f('define');
//        output_port.graphics.pin=21;      
//        diagram.objs(1)=input_port;
//        diagram.objs(2)=split_1;
//        diagram.objs(3)=split_2;
//        diagram.objs(4)=gain_p;
//        diagram.objs(5)=gain_i;
//        diagram.objs(6)=gain_d;
//        diagram.objs(7)=fct_i;      
//        diagram.objs(8)=fct_d;
//        diagram.objs(9)=sum;
//        diagram.objs(10)=output_port;    
//
//        diagram.objs(11)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[1, 1,0], to=[2, 1,1])
//        diagram.objs(12)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[2, 1,0], to=[4, 1,1])
//        diagram.objs(13)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[2, 2,0], to=[3, 1,1])
//        diagram.objs(14)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[3, 1,0], to=[5, 1,1])
//        diagram.objs(15)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[3, 2,0], to=[6, 1,1])
//        diagram.objs(16)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[4, 1,0], to=[9, 1,1])
//        diagram.objs(17)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[5, 1,0], to=[7, 1,1])
//        diagram.objs(18)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[6, 1,0], to=[8, 1,1])
//        diagram.objs(19)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[7, 1,0], to=[9, 2,1])
//        diagram.objs(20)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[8, 1,0], to=[9, 3,1])
//        diagram.objs(21)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[9, 1,0], to=[10, 1,1])
//
        input_port=IN_f('define');
        input_port.graphics.pout=4;
        output_port=OUT_f('define');
        output_port.graphics.pin=5;     
        fct=CLR('define');
        fct.model.state=[0;0]
        fct.model.rpar=[0;0;1;-wc;0;1;wc*I;I-D*wc^2;D*wc+P];
        fct.graphics.exprs=[string(I)+"*"+string(wc)+"+("+string(I)+"+"+string(wc)+'*'+string(P)+')*s+('+string(D)+'*'+string(wc)+'+'+string(P)+')*s^2';'s^2+'+string(wc)+'*s']
        fct.model.dep_ut=[%t,%t]
        fct.graphics.pin=4;
        fct.graphics.pout=5;    
        diagram.objs(1)=fct;
        diagram.objs(2)=input_port;
        diagram.objs(3)=output_port;
        diagram.objs(4)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[2, 1,0], to=[1, 1,1])
        diagram.objs(5)=scicos_link(xx=[0 ; 0],yy=[0 ; 0], ct=[1,1], from=[1, 1,0], to=[3, 1,1])
        
        
        model=scicos_model();
        model.sim='csuper'
        model.blocktype='h';
        model.dep_ut=[%f %f];
        model.rpar=diagram
        model.out=-1
        model.out2=-2
        model.outtyp=-1
        model.in=-1
        model.in2=-2
        model.intyp=-1

        x=standard_define([2 2],model,[],[]);
        x.graphics.in_implicit=['E'];
        x.graphics.out_implicit=['E'];
        x.graphics.style=["blockWithLabel;verticalLabelPosition=center;displayedLabel=PID"]
        x.graphics.exprs=string([P;I;D;wc]);
    end
endfunction


