//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2010-2010 - DIGITEO -
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function REP_TEMP_post_simulate(scs_m)

    // find SCOPE bloc for plotting at the end of simulation
    presence_scope=%f;
    list_scope=[];
    grid_on=0;
    //on recupère les blocs scope et si on veut une grille ou pas
    for i = 1:size(scs_m.objs)
        curObj= scs_m.objs(i);
        if (typeof(curObj) == "Block" & curObj.gui == "SCOPE")
            presence_scope=%t 
            list_scope($+1)=i;
        end
        if (typeof(curObj) == "Block" & curObj.gui == "REP_TEMP") then
            grid_on=evstr(scs_m.objs(i).graphics.exprs(2));
        end
    end  

    nb_outputs_by_scope=[];
    nb_total_outputs=0;
    nb_scope=size(list_scope,1);
    legendes=cell();

    //on parcourt les scope pour en extraire les légendes
    for i=1:size(list_scope,1)
        j=list_scope(i);
        obj=scs_m.objs(j);       
        nb_outputs($+1)=evstr(obj.graphics.exprs(1));
        legendes(i).entries=obj.graphics.exprs(2:$);
        nb_total_outputs=nb_total_outputs+nb_outputs($);
    end

    c_color=[[0.75,0.75,0];[0.25,0.25,0.25];[0,0,1];[0,0.5,0];[1,0,0];[0,0.75,0.75];[0.75,0,0.75]];
    handle_fig=figure();
    set(handle_fig,"background",8)
    drawlater();

    //extraction des champs stockés
    D=[];
    legend_c=[];
    nb_objs_in_scopeblock=3;

    for i=1:nb_scope //pour chaque scope, on extrait les valeurs stockées dans la variable définie pour les scopes
        subplot(nb_scope,1,i);
        legend_c=legendes(i).entries;

        if size(legend_c,1)~=nb_outputs(i) then
            legend_c=_gettext("curv")+string([1:nb_outputs(i)]);
        end

        list_obj=scs_m.objs(list_scope(i)).model.rpar.objs;
        no=1;
        for j=1:size(list_obj)
            if (typeof(list_obj(j)) == "Block" & list_obj(j).gui == "TOWS_c") then
                label=list_obj(j).graphics.exprs(2);
                D(i,no)=evstr(label);
                no=no+1;                                    
            end
        end

        for no=1:nb_outputs(i) //on trace ensuite sur chaque sous figure la réponse 
            plot(D(i,no).time,D(i,no).values,'color',[c_color(modulo(no,6)+1,1),c_color(modulo(no,6)+1,2),c_color(modulo(no,6)+1,3)],'thickness',2)
        end
        ax=gca()
        for i=1:size(ax.children,1)
            ok=datatipInitStruct(ax.children(i).children,"formatfunction","formatTempTip")
        end
        
        h=legend(legend_c);
        
        set(h,"background",8)
        if grid_on==1 then
            xgrid;
        end        

    end
    drawnow();

endfunction

function str=formatTempTip(curve,pt,index)
//this function is called by the datatips mechanism to format the tip
//string for the magnitude bode curves
  str=msprintf("%.4g"+_("s")+"\n%.4g", pt(1),pt(2))
endfunction



